/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(MEDIA_STREAM)

#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "JSEventTarget.h"
#include "MediaStreamTrack.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSMediaStreamTrack : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = MediaStreamTrack;
    static JSMediaStreamTrack* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<MediaStreamTrack>&& impl)
    {
        JSMediaStreamTrack* ptr = new (NotNull, JSC::allocateCell<JSMediaStreamTrack>(globalObject->vm().heap)) JSMediaStreamTrack(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static WEBCORE_EXPORT MediaStreamTrack* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    MediaStreamTrack& wrapped() const
    {
        return static_cast<MediaStreamTrack&>(Base::wrapped());
    }
protected:
    JSMediaStreamTrack(JSC::Structure*, JSDOMGlobalObject&, Ref<MediaStreamTrack>&&);

    void finishCreation(JSC::VM&);
};

class JSMediaStreamTrackOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&, const char**);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, MediaStreamTrack*)
{
    static NeverDestroyed<JSMediaStreamTrackOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(MediaStreamTrack* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, MediaStreamTrack&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, MediaStreamTrack* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<MediaStreamTrack>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<MediaStreamTrack>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<MediaStreamTrack> {
    using WrapperClass = JSMediaStreamTrack;
    using ToWrappedReturnType = MediaStreamTrack*;
};
String convertEnumerationToString(MediaStreamTrack::State);
template<> JSC::JSString* convertEnumerationToJS(JSC::JSGlobalObject&, MediaStreamTrack::State);

template<> Optional<MediaStreamTrack::State> parseEnumeration<MediaStreamTrack::State>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<MediaStreamTrack::State>();

#if ENABLE(MEDIA_STREAM)

template<> MediaStreamTrack::TrackCapabilities convertDictionary<MediaStreamTrack::TrackCapabilities>(JSC::JSGlobalObject&, JSC::JSValue);

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject&, JSDOMGlobalObject&, const MediaStreamTrack::TrackCapabilities&);

#endif

#if ENABLE(MEDIA_STREAM)

template<> MediaStreamTrack::TrackSettings convertDictionary<MediaStreamTrack::TrackSettings>(JSC::JSGlobalObject&, JSC::JSValue);

JSC::JSObject* convertDictionaryToJS(JSC::JSGlobalObject&, JSDOMGlobalObject&, const MediaStreamTrack::TrackSettings&);

#endif


} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)
